---
title: SourceBufferList
slug: Web/API/SourceBufferList
tags:
  - API
  - Audio
  - Experimental
  - Interface
  - MSE
  - Media Source Extensions
  - Reference
  - SourceBufferList
  - Video
---
<p>{{draft}}{{APIRef("Media Source Extensions")}}{{SeeCompatTable}}</p>

<p>The <strong><code>SourceBufferList</code></strong> interface represents a simple container list for multiple {{domxref("SourceBuffer")}} objects.</p>

<p>The source buffer list containing the <code>SourceBuffer</code>s appended to a particular <code>MediaSource</code> can be retrieved using the {{domxref("MediaSource.sourceBuffers")}} property. The individual source buffers can be accessed using array operator (i.e. <code>[]</code>) or functions such as {{jsxref("Array.forEach", "forEach()")}} for example.</p>

<p>{{InheritanceDiagram}}</p>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref("SourceBufferList.length")}} {{readonlyInline}}</dt>
 <dd>Returns the number of {{domxref("SourceBuffer")}} objects in the list.</dd>
</dl>

<h3 id="Event_handlers">Event handlers</h3>

<dl>
 <dt>{{domxref("SourceBufferList.onaddsourcebuffer")}}</dt>
 <dd>The event handler for the <code>addsourcebuffer</code> event.</dd>
 <dt>{{domxref("SourceBufferList.onremovesourcebuffer")}}</dt>
 <dd>The event handler for the <code>removesourcebuffer</code> event.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>Inherits methods from its parent interface, {{domxref("EventTarget")}}.</em></p>

<dl>
 <dt><a href="/en-US/docs/Web/API/SourceBufferList/SourceBuffer"><code>SourceBufferList</code>: indexed property getter</a></dt>
 <dd>This getter allows the <code>SourceBuffer</code> objects in the list to be accessed with an array operator (i.e. <code>[]</code>.)</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>TBD.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Media Source Extensions', '#sourcebufferlist', 'SourceBufferList')}}</td>
   <td>{{Spec2('Media Source Extensions')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.SourceBufferList")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("MediaSource")}}</li>
 <li>{{domxref("SourceBuffer")}}</li>
</ul>
